Subject: Re: linux-next: build failure after merge of the tegra tree

From: Thierry Reding <[email-masked]>
Date: Wed, 6 Oct 2021 20:00:32 +0200

On Tue, Oct 05, 2021 at 02:54:43AM +0300, Dmitry Osipenko wrote:
> 05.10.2021 02:39, Stephen Rothwell пишет:
> > Hi all,
> > 
> > After merging the tegra tree, today's linux-next build (x86_64
> > allmodconfig) failed like this:
> > 
> > In file included from arch/x86/include/asm/bug.h:84,
> >                  from include/linux/bug.h:5,
> >                  from arch/x86/include/asm/paravirt.h:15,
> >                  from arch/x86/include/asm/irqflags.h:63,
> >                  from include/linux/irqflags.h:16,
> >                  from include/linux/rcupdate.h:26,
> >                  from include/linux/rculist.h:11,
> >                  from include/linux/pid.h:5,
> >                  from include/linux/sched.h:14,
> >                  from include/linux/ratelimit.h:6,
> >                  from include/linux/dev_printk.h:16,
> >                  from include/linux/device.h:15,
> >                  from include/linux/of_reserved_mem.h:5,
> >                  from drivers/memory/tegra/tegra210-emc-table.c:6:
> > include/linux/clk/tegra.h: In function 'tegra_cpu_rail_off_ready':
> > include/linux/clk/tegra.h:112:15: error: 'tegra_cpu_car_ops' undeclared (first use in this function)
> >   112 |  if (WARN_ON(!tegra_cpu_car_ops->rail_off_ready))
> >       |               ^~~~~~~~~~~~~~~~~
> > include/asm-generic/bug.h:121:25: note: in definition of macro 'WARN_ON'
> >   121 |  int __ret_warn_on = !!(condition);    \
> >       |                         ^~~~~~~~~
> > include/linux/clk/tegra.h:112:15: note: each undeclared identifier is reported only once for each function it appears in
> >   112 |  if (WARN_ON(!tegra_cpu_car_ops->rail_off_ready))
> >       |               ^~~~~~~~~~~~~~~~~
> > include/asm-generic/bug.h:121:25: note: in definition of macro 'WARN_ON'
> >   121 |  int __ret_warn_on = !!(condition);    \
> >       |                         ^~~~~~~~~
> > include/linux/clk/tegra.h: In function 'tegra_cpu_clock_suspend':
> > include/linux/clk/tegra.h:120:15: error: 'tegra_cpu_car_ops' undeclared (first use in this function)
> >   120 |  if (WARN_ON(!tegra_cpu_car_ops->suspend))
> >       |               ^~~~~~~~~~~~~~~~~
> > include/asm-generic/bug.h:121:25: note: in definition of macro 'WARN_ON'
> >   121 |  int __ret_warn_on = !!(condition);    \
> >       |                         ^~~~~~~~~
> > include/linux/clk/tegra.h: In function 'tegra_cpu_clock_resume':
> > include/linux/clk/tegra.h:128:15: error: 'tegra_cpu_car_ops' undeclared (first use in this function)
> >   128 |  if (WARN_ON(!tegra_cpu_car_ops->resume))
> >       |               ^~~~~~~~~~~~~~~~~
> > include/asm-generic/bug.h:121:25: note: in definition of macro 'WARN_ON'
> >   121 |  int __ret_warn_on = !!(condition);    \
> >       |                         ^~~~~~~~~
> > In file included from arch/x86/include/asm/bug.h:84,
> >                  from include/linux/bug.h:5,
> >                  from include/linux/cpumask.h:14,
> >                  from arch/x86/include/asm/cpumask.h:5,
> >                  from arch/x86/include/asm/msr.h:11,
> >                  from arch/x86/include/asm/processor.h:22,
> >                  from arch/x86/include/asm/timex.h:5,
> >                  from include/linux/timex.h:65,
> >                  from include/linux/time32.h:13,
> >                  from include/linux/time.h:60,
> >                  from include/linux/stat.h:19,
> >                  from include/linux/module.h:13,
> >                  from drivers/media/cec/platform/tegra/tegra_cec.c:14:
> > include/linux/clk/tegra.h: In function 'tegra_cpu_rail_off_ready':
> > include/linux/clk/tegra.h:112:15: error: 'tegra_cpu_car_ops' undeclared (first use in this function)
> >   112 |  if (WARN_ON(!tegra_cpu_car_ops->rail_off_ready))
> >       |               ^~~~~~~~~~~~~~~~~
> > include/asm-generic/bug.h:121:25: note: in definition of macro 'WARN_ON'
> >   121 |  int __ret_warn_on = !!(condition);    \
> >       |                         ^~~~~~~~~
> > include/linux/clk/tegra.h:112:15: note: each undeclared identifier is reported only once for each function it appears in
> >   112 |  if (WARN_ON(!tegra_cpu_car_ops->rail_off_ready))
> >       |               ^~~~~~~~~~~~~~~~~
> > include/asm-generic/bug.h:121:25: note: in definition of macro 'WARN_ON'
> >   121 |  int __ret_warn_on = !!(condition);    \
> >       |                         ^~~~~~~~~
> > include/linux/clk/tegra.h: In function 'tegra_cpu_clock_suspend':
> > include/linux/clk/tegra.h:120:15: error: 'tegra_cpu_car_ops' undeclared (first use in this function)
> >   120 |  if (WARN_ON(!tegra_cpu_car_ops->suspend))
> >       |               ^~~~~~~~~~~~~~~~~
> > include/asm-generic/bug.h:121:25: note: in definition of macro 'WARN_ON'
> >   121 |  int __ret_warn_on = !!(condition);    \
> >       |                         ^~~~~~~~~
> > include/linux/clk/tegra.h: In function 'tegra_cpu_clock_resume':
> > include/linux/clk/tegra.h:128:15: error: 'tegra_cpu_car_ops' undeclared (first use in this function)
> >   128 |  if (WARN_ON(!tegra_cpu_car_ops->resume))
> >       |               ^~~~~~~~~~~~~~~~~
> > include/asm-generic/bug.h:121:25: note: in definition of macro 'WARN_ON'
> >   121 |  int __ret_warn_on = !!(condition);    \
> >       |                         ^~~~~~~~~
> > 
> > Presumably caused by commit
> > 
> >   bbe30ae68d14 ("cpuidle: tegra: Enable compile testing")
> > 
> > I have used the tegra tree from next-20211001 for today.
> > 
> 
> Stephen, thank you. Now I recall what was the actual reason for my
> version of the patch [1]. Thierry, please use my original patch, thanks.
> 
> [1]
> https://patchwork.ozlabs.org/project/linux-tegra/patch/[email-masked]/

Sorry, I forgot to reply to this yesterday. I found a simpler fix for
this and I pushed that yesterday. Today's linux-next didn't have the
build failure anymore, so I guess it worked.

Thierry